<?php

namespace Factory;

class Attachment {
    public function createAttachment($typeFile, $nameFile, $labelFile, $sizeFile, $deploy, $deployScript = null, $customization = null){
        $entity = new \Zeedhi\DevOps\Model\Projectmanagement\Entities\Attachment();
        $entity->setFileName($nameFile);
        $entity->setSizeFile($sizeFile);
        $entity->setTypeFile($typeFile);
        $entity->setLabel($labelFile);
        $entity->setDeploy($deploy);
        $entity->setDeployScript($deployScript);
        $entity->setDeployCustomization($customization);
        return $entity;
    }

    public function updateAttachmentPath(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Attachment $entity, $fileName, $deployScript = null){
        $entity->setFileName($fileName);
        $entity->setDeployScript($deployScript);
        return $entity;
    }

    public static function createArrayAttachmentTicket($cdoperador, $dscaminho, $dstipo, $nmaquivo, $nrorg,
                                                $nrseqcontato,$vrtamanho,$nrorigem = null){
        $idorigem = "EVOLUCAO";
        if(is_null($nrorigem)){
            $nrorigem = $nrseqcontato;
            $idorigem = "CONTATO";
        }
        $attachment = array(
            'CDOPERADOR' => $cdoperador,
            'DSCAMINHO' => $dscaminho,
            'DSTIPO' => $dstipo,
            'IDATIVO' => "S",
            'IDORIGEM' => $idorigem,
            'NMARQUIVO' => $nmaquivo,
            'NRORG' => $nrorg,
            'NRORIGEM' => $nrorigem,
            'NRSEQCONTATO' => $nrseqcontato,
            'VRTAMANHO' => $vrtamanho,
            '__is_new' => true,
        );
        return $attachment;
    }
}
