<?php

namespace Factory;

use Zeedhi\DevOps\Model\Configurationmanager\Entities\DeployCustomization as DeployCustomizationEntity;
use Zeedhi\DevOps\Model\Configurationmanager\Entities\Product;
use Zeedhi\DevOps\Model\Projectmanagement\Entities\Resource;
use Zeedhi\DevOps\Model\Servermanager\Entities\ProductServer;

class DeployCustomization {
    public function save(DeployCustomizationEntity $deployCustomization = null, Product $product, ProductServer $productServer, Resource $resource,
                         $description, $deployDate, $status, $version, $previousVersion, $isActive = 'Y') {

        if(empty($deployCustomization)) {
            $deployCustomization = new DeployCustomizationEntity();
        }

        $deployCustomization->setProduct($product);
        $deployCustomization->setProductServer($productServer);
        $deployCustomization->setResource($resource);
        $deployCustomization->setDeployDate($deployDate);
        $deployCustomization->setDescription($description);
        $deployCustomization->setStatus($status);
        $deployCustomization->setVersion($version);
        $deployCustomization->setPreviousVersion($previousVersion);
        $deployCustomization->setIsActive($isActive);

        return $deployCustomization;
    }

    public function saveAfterApply(DeployCustomizationEntity $deployCustomization, $deployDate, $status, $version, $previousVersion, 
                                   $isActive, $migFullLog, $migErrorLog) {
        $deployCustomization->setDeployDate($deployDate);
        $deployCustomization->setStatus($status);
        $deployCustomization->setVersion($version);
        $deployCustomization->setPreviousVersion($previousVersion);
        $deployCustomization->setIsActive($isActive);
        
        if(!empty($migFullLog)) {
            $deployCustomization->setMigFullLog($migFullLog);
        }
        if(!empty($migErrorLog)) {
            $deployCustomization->setMigErrorLog($migErrorLog);
        }

        return $deployCustomization;
    }
}
